<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="s" uri="/struts-tags" %>

<script type="text/javascript">
	var djConfig = { isDebug: false };
</script>

<script src="/MGA/struts/dojo/dojo.js" type="text/javascript"></script>

<script type="text/javascript">
	dojo.require("dojo.io.*");
	dojo.require("dojo.rpc.*");
	dojo.require("dojo.widget.FilteringTable");
	dojo.hostenv.writeIncludes();
</script>

<s:url id="smdUrl" namespace="/nodecorate" action="SomeListRpc"/>
<script type="text/javascript">
	var currentPage = 0;
	var service = new dojo.rpc.JsonService("${smdUrl}");
</script>

First Name:<input type="text" id="filterFirstName">
Second Name:<input type="text" id="filterSecondName">
<button onclick="refreshData()">Search</button><br>

<span id="testTablePagination"></span>

<table dojoType="filteringTable" id="yourTableId"
	   multiple="false" alternateRows="true" valueField="id">
	<thead>
		<tr>
			<th field="id" dataType="String">ID</th>
			<th field="firstName" dataType="String">First Name</th>
			<th field="secondName" dataType="String">Second Name</th>
		</tr>
	</thead>
</table>

<script type="text/javascript">
	refreshData = function() {
		// define a callback function for row data
		var rowsCallback = function(bean) {
			var yourTable = dojo.widget.byId('yourTableId');
			yourTable.store.setData(bean);
		};
		var yourTable = dojo.widget.byId('yourTableId');
		// construct filter based on current FilteringTable sort information
		var sortInfo = yourTable.sortInformation[0];
		var filter = {field:yourTable.columns[sortInfo.index].field,direction:sortInfo.direction,page:currentPage};
		// add criteria to filter, dynamically construct your own
		filter['criteria'] = {firstName:document.getElementById('filterFirstName').value,secondName:document.getElementById('filterSecondName').value};
		var deferred = service.getRows(filter);
		// start the RPC process
		deferred.addCallback(rowsCallback);

		var rowNumCallback = function(rowNumber) {
			var totalPages = Math.ceil(rowNumber / 10);
			// call your fillPagination function rendering pagination info
			fillPagination(totalPages);
		}
		// we don't need sort and page info to count rows, just filtering criteria
		filter = {field:'',direction:1,page:0};
		filter['criteria'] = {firstName:document.getElementById('filterFirstName').value,secondName:document.getElementById('filterSecondName').value};
		var deferred = service.getRowCount(filter);
		// start the RPC process
		deferred.addCallback(rowNumCallback);
	}

	fillPagination = function(totalPages) {
		var el = document.getElementById('testTablePagination');
		el.innerHTML = 'Pages:&nbsp;';
		for (var i = 0; i < totalPages; i++) {
			if (currentPage == i) {
				el.innerHTML += '<b>' + (i + 1) + '</b>&nbsp;';
			} else {
				el.innerHTML += '<a href="#" onclick="currentPage=' + i + '; refreshData();">' + (i + 1) + '</a>&nbsp;';
			}
		}
	}
</script>

<script type="text/javascript">
	dojo.addOnLoad(function() {
		var yourTable = dojo.widget.byId('yourTableId');
		yourTable.createSorter = function() { return null;};
		dojo.event.connect("after", yourTable, "onSelect", function () { onSelectFunc(); });
		dojo.event.connect("after", yourTable, "onSort", function () { refreshData(); });
		refreshData();
	});
</script>
